summaryrefslogtreecommitdiff
path: root/tests/chgrp/deref.sh
diff options
context:
space:
mode:
authorStefano Lattarini <stefano.lattarini@gmail.com>2012-08-30 14:13:12 +0200
committerJim Meyering <meyering@redhat.com>2012-08-30 18:55:59 +0200
commit9eb4c31eb78c28dd9f72d1cbb940270311be343c (patch)
treeea3078bc1b002a9f948ed41445ca32318002a1d3 /tests/chgrp/deref.sh
parent00f5ba15dd91a3d9780fe1fbd06a4df436ae6714 (diff)
downloadcoreutils-9eb4c31eb78c28dd9f72d1cbb940270311be343c.tar.xz
tests: add .sh and .pl suffixes to shell and perl tests, respectively
Not only this shrinks the size of the generated Makefile (from > 6300 lines to ~3000), but will allow further simplifications in future changes. * tests/Makefile.am (TEST_EXTENSIONS): Add '.sh' and '.pl'. (PL_LOG_COMPILER, SH_LOG_COMPILER): New, still defined simply to $(LOG_COMPILER) for the time being. (TESTS, root_tests): Adjust as described. * All tests: Rename as described.
Diffstat (limited to 'tests/chgrp/deref.sh')
-rwxr-xr-xtests/chgrp/deref.sh60
1 files changed, 60 insertions, 0 deletions
diff --git a/tests/chgrp/deref.sh b/tests/chgrp/deref.sh
new file mode 100755
index 000000000..4c186ee82
--- /dev/null
+++ b/tests/chgrp/deref.sh
@@ -0,0 +1,60 @@
+#!/bin/sh
+# see if chgrp can change the group of a symlink
+
+# Copyright (C) 2000-2012 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ chgrp
+require_membership_in_two_groups_
+
+set _ $groups; shift
+g1=$1
+g2=$2
+
+touch f
+ln -s f symlink
+
+chgrp -h $g2 symlink 2> /dev/null
+set _ $(ls -ln symlink)
+g=$5
+test "$g" = $g2 ||
+ skip_ "your system doesn't support changing the owner or group" \
+ "of a symbolic link."
+
+
+chgrp $g1 f
+set _ $(ls -ln f); g=$5; test "$g" = $g1 || fail=1
+
+chgrp -h $g2 symlink || fail=1
+set _ $(ls -ln f); g=$5; test "$g" = $g1 || fail=1
+set _ $(ls -ln symlink); g=$5; test "$g" = $g2 || fail=1
+
+# This should not change the group of f.
+chgrp -h $g2 symlink || fail=1
+set _ $(ls -ln f); g=$5; test "$g" = $g1 || fail=1
+set _ $(ls -ln symlink); g=$5; test "$g" = $g2 || fail=1
+
+chgrp $g2 f
+set _ $(ls -ln f); g=$5; test "$g" = $g2 || fail=1
+
+# This *should* change the group of f.
+# Though note that the diagnostic you'd get with -c is misleading in that
+# it says the 'group of 'symlink'' has been changed.
+chgrp --dereference $g1 symlink
+set _ $(ls -ln f); g=$5; test "$g" = $g1 || fail=1
+set _ $(ls -ln symlink); g=$5; test "$g" = $g2 || fail=1
+
+Exit $fail